Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/resources.cfg
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/resources.cfg	(revision 1242)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/resources.cfg	(revision 2104)
@@ -21,4 +21,5 @@
 FileSystem=../../../../../resources/models
 FileSystem=../../../../../resources/models/trees
+FileSystem=../../../../../resources/media
 Zip=../../../Media/packs/cubemap.zip
 Zip=../../../Media/packs/cubemapsJS.zip
Index: /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.aux
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.aux	(revision 2068)
+++ /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.aux	(revision 2104)
@@ -12,8 +12,8 @@
 \newlabel{sec:BoundingBoxConverter}{{4.1}{3}}
 \@writefile{toc}{\contentsline {paragraph}{BoundingBoxConverter}{3}}
-\newlabel{sec:ObjectContainer}{{4.1}{3}}
-\@writefile{toc}{\contentsline {paragraph}{ObjectContainer}{3}}
-\newlabel{sec:Loading}{{4.1}{3}}
-\@writefile{toc}{\contentsline {paragraph}{ViewCellsManager}{3}}
+\newlabel{sec:ObjectContainer}{{4.1}{4}}
+\@writefile{toc}{\contentsline {paragraph}{ObjectContainer}{4}}
+\newlabel{sec:Loading}{{4.1}{4}}
+\@writefile{toc}{\contentsline {paragraph}{ViewCellsManager}{4}}
 \@writefile{toc}{\contentsline {section}{\numberline {5}Example Implementation}{4}}
 \newlabel{sec:implementation}{{5}{4}}
Index: /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.tex
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.tex	(revision 2074)
+++ /GTP/trunk/Lib/Vis/Preprocessing/manual/integration.tex	(revision 2104)
@@ -63,6 +63,5 @@
 \label{sec:requirements}
 
-Add the following libraries to your application. These libaries are all part of the {\em NonGtp} directory 
-of the repository.%Next the preprocessor must be build
+Add the following libraries to your application. 
 
 \begin{itemize}
@@ -77,4 +76,19 @@
 \item {\em glew32.lib }
 \item {\em glew32s.lib }
+\end{itemize}
+
+The libraries can be found in the following directories.
+
+\begin{itemize}
+\item {\em trunk/Lib/Vis/Preprocessing/lib/Release }
+\item {\em GTP/trunk/Lib/Vis/Preprocessing/src/GL }
+\item {\em NonGTP/Xerces/xercesc/lib }
+\item {\em NonGTP/Zlib/lib }
+\end{itemize}
+
+This include directory must be added to your Solution.
+
+\begin{itemize}
+\item {\em GTP/trunk/Lib/Vis/Preprocessing/src }
 \end{itemize}
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.log
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.log	(revision 2074)
+++ /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.log	(revision 2104)
@@ -1,3 +1,3 @@
-This is pdfeTeX, Version 3.141592-1.21a-2.2 (MiKTeX 2.4) (preloaded format=latex 2005.8.25)  1 FEB 2007 18:44
+This is pdfeTeX, Version 3.141592-1.21a-2.2 (MiKTeX 2.4) (preloaded format=latex 2005.8.25)  8 FEB 2007 14:02
 entering extended mode
 **D:/svn/gametools/GTP/trunk/Lib/Vis/Preprocessing/manual/manual.tex
@@ -180,5 +180,5 @@
 LaTeX Font Info:    Font shape `OT1/ptm/bx/n' in size <12> not available
 (Font)              Font shape `OT1/ptm/b/n' tried instead on input line 62.
-LaTeX Font Info:    Try loading font information for OMS+ptm on input line 69.
+LaTeX Font Info:    Try loading font information for OMS+ptm on input line 68.
 
 (D:\texmf\tex\latex\psnfss\omsptm.fd
@@ -186,9 +186,9 @@
 )
 LaTeX Font Info:    Font shape `OMS/ptm/m/n' in size <10> not available
-(Font)              Font shape `OMS/cmsy/m/n' tried instead on input line 69.
+(Font)              Font shape `OMS/cmsy/m/n' tried instead on input line 68.
  [2
 
 ] [3]
-Overfull \hbox (1.41376pt too wide) in paragraph at lines 181--181
+Overfull \hbox (1.41376pt too wide) in paragraph at lines 195--195
 []                                \OT1/pcr/m/n/10 IntersectableWrapper<EntityCo
 ntainer *>[] 
@@ -196,5 +196,5 @@
 
 
-Overfull \hbox (19.41376pt too wide) in paragraph at lines 181--181
+Overfull \hbox (19.41376pt too wide) in paragraph at lines 195--195
 []   \OT1/pcr/m/n/10 EngineIntersectable(EntityContainer *item): GtpVisibilityP
 reprocessor::[] 
@@ -202,17 +202,17 @@
 
 [4]
-Overfull \hbox (31.41376pt too wide) in paragraph at lines 265--265
+Overfull \hbox (31.41376pt too wide) in paragraph at lines 279--279
 []       \OT1/pcr/m/n/10 const GtpVisibilityPreprocessor::IndexedBoundingBoxCon
 tainer &iboxes,[] 
  []
 
-
-Overfull \hbox (1.41376pt too wide) in paragraph at lines 265--265
+[5]
+Overfull \hbox (1.41376pt too wide) in paragraph at lines 279--279
 []    \OT1/pcr/m/n/10 EngineIntersectable *entry = new EngineIntersectable(entr
 yObjects);[] 
  []
 
-[5]
-Overfull \hbox (1.41376pt too wide) in paragraph at lines 314--314
+
+Overfull \hbox (1.41376pt too wide) in paragraph at lines 328--328
 []  \OT1/pcr/m/n/10 for (sit = sceneNodeList.begin(); sit != sceneNodeList.end(
 ); ++ sit)[] 
@@ -220,5 +220,5 @@
 
 
-Overfull \hbox (7.41376pt too wide) in paragraph at lines 314--314
+Overfull \hbox (7.41376pt too wide) in paragraph at lines 328--328
 []      \OT1/pcr/m/n/10 // test for intersection (note: function provided of pr
 eprocessor)[] 
@@ -229,5 +229,5 @@
  1532 strings out of 95515
  16755 string characters out of 1189489
- 65463 words of memory out of 1065662
+ 64951 words of memory out of 1065662
  4500 multiletter control sequences out of 60000
  21808 words of font info for 49 fonts, out of 1000000 for 2000
@@ -242,3 +242,3 @@
 \urw\urwstd\utmri8a.pfb><D:\texmf\fonts\type1\urw\urwstd\utmb8a.pfb><D:\texmf\f
 onts\type1\urw\urwstd\utmr8a.pfb>
-Output written on manual.pdf (7 pages, 82172 bytes).
+Output written on manual.pdf (7 pages, 82926 bytes).
Index: /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.toc
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.toc	(revision 2068)
+++ /GTP/trunk/Lib/Vis/Preprocessing/manual/manual.toc	(revision 2104)
@@ -5,6 +5,6 @@
 \contentsline {subsection}{\numberline {4.1}Requirements}{2}
 \contentsline {paragraph}{BoundingBoxConverter}{3}
-\contentsline {paragraph}{ObjectContainer}{3}
-\contentsline {paragraph}{ViewCellsManager}{3}
+\contentsline {paragraph}{ObjectContainer}{4}
+\contentsline {paragraph}{ViewCellsManager}{4}
 \contentsline {section}{\numberline {5}Example Implementation}{4}
 \contentsline {subsection}{\numberline {5.1}Intersectable}{4}