Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjManualMeshLoader.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjManualMeshLoader.h	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjManualMeshLoader.h	(revision 2110)
@@ -4,5 +4,5 @@
 
 #include "Ogre.h"
-#include "ivmeshdata.h"
+#include "ObjMeshData.h"
 
 
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h	(revision 2110)
@@ -3,8 +3,8 @@
 
 
-#include "ivnode.h"
-#include "ivmeshdata.h"
-#include "ivmanualmeshloader.h"
-#include "ogre.h"
+#include "ObjNode.h"
+#include "ObjMeshData.h"
+#include "ObjManualMeshLoader.h"
+#include "Ogre.h"
 
 #define COMMENTCHAR '#'
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj	(revision 2110)
@@ -3,5 +3,5 @@
 	ProjectType="Visual C++"
 	Version="7.10"
-	Name="IVReader"
+	Name="ObjReader"
 	ProjectGUID="{7319E499-473D-4CE5-9983-725D6E68A55D}"
 	Keyword="Win32Proj">
@@ -21,5 +21,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
 				MinimalRebuild="TRUE"
 				BasicRuntimeChecks="3"
@@ -34,5 +34,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="OgreMain_d.lib CEGUIBase_d.lib OgreGUIRenderer_d.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;"
@@ -40,5 +40,5 @@
 				ProgramDatabaseFile="$(OutDir)/$(ProjectName).pdb"
 				SubSystem="2"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -73,16 +73,16 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
-				RuntimeLibrary="2"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;"
@@ -91,5 +91,5 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -124,16 +124,16 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
-				RuntimeLibrary="2"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;"
@@ -142,5 +142,5 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -175,16 +175,16 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
-				RuntimeLibrary="2"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;"
@@ -193,5 +193,5 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -235,5 +235,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
 				StringPooling="TRUE"
 				RuntimeLibrary="2"
@@ -247,5 +247,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\Release&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;..\..\GtpVisibility\lib\Release;..\..\lib\Release;..\lib\Release;&quot;$(OGRE_PATH)\Dependencies\lib\Release&quot;"
@@ -255,5 +255,5 @@
 				EnableCOMDATFolding="2"
 				OptimizeForWindows98="1"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -288,16 +288,16 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;IVREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
-				RuntimeLibrary="2"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
-				OutputFile="$(OutDir)/IVReader.dll"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="OgreMain.lib CEGUIBase.lib OgreGUIRenderer.lib"
+				OutputFile="$(OutDir)/ObjReader.dll"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;"
@@ -306,5 +306,5 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
-				ImportLibrary="$(OutDir)/IVReader.lib"
+				ImportLibrary="$(OutDir)/ObjReader.lib"
 				TargetMachine="1"/>
 			<Tool
@@ -339,14 +339,14 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
 			<File
-				RelativePath="..\src\ivmanualmeshloader.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ivmeshdata.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ivnode.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ivreader.cpp">
+				RelativePath="..\src\ObjManualMeshLoader.cpp">
+			</File>
+			<File
+				RelativePath="..\src\ObjMeshData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\ObjNode.cpp">
+			</File>
+			<File
+				RelativePath="..\src\ObjReader.cpp">
 			</File>
 		</Filter>
@@ -356,14 +356,14 @@
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
 			<File
-				RelativePath="..\include\ivmanualmeshloader.h">
-			</File>
-			<File
-				RelativePath="..\include\ivmeshdata.h">
-			</File>
-			<File
-				RelativePath="..\include\ivnode.h">
-			</File>
-			<File
-				RelativePath="..\include\ivreader.h">
+				RelativePath="..\include\ObjManualMeshLoader.h">
+			</File>
+			<File
+				RelativePath="..\include\ObjMeshData.h">
+			</File>
+			<File
+				RelativePath="..\include\ObjNode.h">
+			</File>
+			<File
+				RelativePath="..\include\ObjReader.h">
 			</File>
 		</Filter>
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjNode.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjNode.cpp	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjNode.cpp	(revision 2110)
@@ -1,4 +1,4 @@
-#include "ivnode.h"
-#include "ivreader.h"
+#include "ObjNode.h"
+#include "ObjReader.h"
 
 IVField::IVField()
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjMeshData.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjMeshData.cpp	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjMeshData.cpp	(revision 2110)
@@ -1,4 +1,4 @@
-#include "ivmeshdata.h"
-#include "ivreader.h"
+#include "ObjMeshData.h"
+#include "ObjReader.h"
 
 
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjManualMeshLoader.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjManualMeshLoader.cpp	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjManualMeshLoader.cpp	(revision 2110)
@@ -1,4 +1,4 @@
-#include "ivmanualmeshloader.h"
-#include "ivreader.h"
+#include "ObjManualMeshLoader.h"
+#include "ObjReader.h"
 
 IVManualMeshLoader::IVManualMeshLoader()
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.cpp	(revision 2109)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.cpp	(revision 2110)
@@ -1,3 +1,3 @@
-#include "IVReader.h"
+#include "ObjReader.h"
 #include <string>
 #include <stdlib.h>
Index: GTP/trunk/Lib/Vis/GtpVisibility.sln
===================================================================
--- GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 2100)
+++ GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 2110)
@@ -38,4 +38,8 @@
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436} = {80DECC17-BDDD-4412-8CF8-F7C1C17A7436}
 		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ObjReader", "OnlineCullingCHC\ObjReader\src\ObjReader.vcproj", "{7319E499-473D-4CE5-9983-725D6E68A55D}"
+	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
@@ -56,4 +60,5 @@
 		Release Internal = Release Internal
 		Release Static = Release Static
+		Release_Internal = Release_Internal
 		release_noqt = release_noqt
 		Release_qt = Release_qt
@@ -94,4 +99,6 @@
 		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release Static.ActiveCfg = Release|Win32
 		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release Static.Build.0 = Release|Win32
+		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release_Internal.Build.0 = Release_Internal|Win32
 		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.release_noqt.ActiveCfg = Release_qt|Win32
 		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.release_noqt.Build.0 = Release_qt|Win32
@@ -138,4 +145,6 @@
 		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release Static.ActiveCfg = Release|Win32
 		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release Static.Build.0 = Release|Win32
+		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release_Internal.Build.0 = Release_Internal|Win32
 		{101A7691-74F3-48B4-96A3-CF35578F5900}.release_noqt.ActiveCfg = Release_qt|Win32
 		{101A7691-74F3-48B4-96A3-CF35578F5900}.release_noqt.Build.0 = Release_qt|Win32
@@ -182,4 +191,6 @@
 		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Static.ActiveCfg = Release|Win32
 		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Static.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_Internal.Build.0 = Release_Internal|Win32
 		{7319E499-473D-4CE5-9983-725D6E68A55D}.release_noqt.ActiveCfg = Release_qt|Win32
 		{7319E499-473D-4CE5-9983-725D6E68A55D}.release_noqt.Build.0 = Release_qt|Win32
@@ -226,4 +237,6 @@
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release Static.ActiveCfg = Release|Win32
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release Static.Build.0 = Release|Win32
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release_Internal.Build.0 = Release_Internal|Win32
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.release_noqt.ActiveCfg = Release_Internal|Win32
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.release_noqt.Build.0 = Release_Internal|Win32
@@ -270,4 +283,6 @@
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release Static.ActiveCfg = Release|Win32
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release Static.Build.0 = Release|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_Internal.Build.0 = Release_Internal|Win32
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.release_noqt.ActiveCfg = release_noqt|Win32
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.release_noqt.Build.0 = release_noqt|Win32
@@ -314,4 +329,6 @@
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release Static.ActiveCfg = Release|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release Static.Build.0 = Release|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_Internal.ActiveCfg = Release_Qt|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_Internal.Build.0 = Release_Qt|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.release_noqt.ActiveCfg = release_noqt|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.release_noqt.Build.0 = release_noqt|Win32
@@ -358,4 +375,6 @@
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release Static.ActiveCfg = Release|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release Static.Build.0 = Release|Win32
+		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release_Internal.Build.0 = Release_Internal|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.release_noqt.ActiveCfg = Release_qt|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.release_noqt.Build.0 = Release_qt|Win32
@@ -402,4 +421,6 @@
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Release Static.ActiveCfg = Release|Win32
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Release Static.Build.0 = Release|Win32
+		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Release_Internal.Build.0 = Release_Internal|Win32
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.release_noqt.ActiveCfg = Release_qt|Win32
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.release_noqt.Build.0 = Release_qt|Win32
@@ -418,4 +439,50 @@
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Universal Unicode Release.ActiveCfg = Release|Win32
 		{17F2C6F9-6101-430E-ABF4-71383868EF24}.Universal Unicode Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug Static.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug Static.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Unicode Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Unicode Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Unicode Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Unicode Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Unicode Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Unicode Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Unicode Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.DLL Universal Unicode Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.mlrt.ActiveCfg = mlrt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.mlrt.Build.0 = mlrt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Internal.ActiveCfg = Release Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Internal.Build.0 = Release Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Static.ActiveCfg = Release Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release Static.Build.0 = Release Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_Internal.ActiveCfg = Release_Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_Internal.Build.0 = Release_Internal|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.release_noqt.ActiveCfg = Release_qt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.release_noqt.Build.0 = Release_qt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_qt.ActiveCfg = Release_qt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release_qt.Build.0 = Release_qt|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Unicode Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Unicode Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Unicode Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Unicode Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Release.Build.0 = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Unicode Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Unicode Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Unicode Release.ActiveCfg = Release|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Universal Unicode Release.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution